import java.io.*;
import javax.naming.*;
import javax.naming.directory.*;


public class ldapop 
{
public static void main(String args[])
  {
    String hn=args[0];
    String user=args[1];
    String fileName = args[2];
    String physicalFileName=args[3];
    
    modifyFileContent(hn,user, fileName, physicalFileName);
        
  }
  
  

public void modifyFileContent(String hn,String user,String fileName,
			      String physicalFileName)
  {

    String fileContent = readFileContent(fileName);
    if (fileContent == null){
      System.out.println("I can read the file "+fileName);
      return;
    }
    
    Hashtable env = new Hashtable(5, 0.75f);
    env.put(Context.INITIAL_CONTEXT_FACTORY,
	    "com.sun.jndi.ldap.LdapCtxFactory");
 
    /* Specify host and port to use for directory service */
    env.put(Context.PROVIDER_URL, "ldap://jules.ncsa.uiuc.edu:2323");
    env.put(Context.REFERRAL, "follow");

    try {
      /* get a handle to an Initial DirContext */
      DirContext ctx = new InitialDirContext(env);
    
      /* construct the list of modifications to make */
      ModificationItem[] mods = new ModificationItem[1];
      Attribute mod0 = new BasicAttribute("content", fileContent);
      // Update mail attribute
      mods[0] = new ModificationItem(DirContext.REPLACE_ATTRIBUTE, mod0);
  
      String entryDN = "cn"+fileName+",cn="+user+",hn="+hn
	+",o=NCSA,o=WebFlow,c=US";
      
      System.out.println("UserDN :"+entryDN );
      
      /* make the change */
      ctx.modifyAttributes(entryDN, mods);
    } catch (NamingException e) {
        System.err.println("modification failed. " + e);
    }
    
  }
  
  

public void  writeFileContent(String filename,String fileContent)

   {
     try{
       file = new FileOutputStream(fileName);
     }catch(IOException e){
       System.err.println("File:"+filename
			  +" could not be opened for writing");
       return;
     }
     catch(SecurityException e){
       System.out.println("It is not allowed write access to file :"+filename);
       return;
     }

     try{
       DataOutputStream out = new DataOutputStream(file);
       //write fileContent to file at once
       out.writeBytes(fileContent);
     }catch(IOException e){
       System.err.println("There is IOException during writing file:"+e);
     }
 
   }


   String readFileContent(String filename)
   {
     char[] data = null;
     File file = new File(fileName);
     
     if ((!file.exists())||(!file.canRead())){
       System.out.println("File:"+filename+
			  " doesn't exist or I can not read it");
       return null;
     }
       
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
	 chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.out.println("There is IOException during reading file:"+e);
     }
      
      return new String(data);
   }
   
}

